unit UDane;
interface
uses UObiekty;
const
 IloscIkon     = 187;
 RozmiarIkon   = 518;
 SciezkaDane   = 'DANE\';
 SciezkaLevels = 'LEVELS\';

 { kierunki }

type
 TTablica  = array[1..IloscIkon] of pointer;
 TTablica2 = array[1..20,1..13] of PPole;
 string80  = string[82];
 string4   = string[4];
 TTablica3 = array[1..20,1..13] of string4;
var
 Ikony:TTablica;
 Plansza:TTablica2;
 Pole:PPole;
 Nazwa:string;
 NazwaW:string;
 KoniecGry:boolean;

procedure OdczytajDane;
procedure WyswietlDane;
procedure OdczytajPlansze(Nazwa:string);
procedure PlanszaKoniec;
procedure DaneKoniec;
procedure PustaPlansza;
procedure NowaPlansza(APr:TProc;X,Y:integer;Kod:string;Rys:PRys;var Plansza:PPole);

implementation

uses UProcedury,UInfo,Plik,Graph,m2mouse,UWykonaj;

procedure WyswietlTekst(Text:string);
begin
 Text:=Copy(Text,10,length(Text)-10);
 SetColor(15);
 OutTextXY(200,0,'Nazwa : '+Text);
end;
procedure WyswietlDane;
begin
 SetColor(15);
 OutTextXY(0,0,Nazwa);
 WyswietlTekst(NazwaW);
end;
procedure OdczytajDane;
var
 f:file;
 a:integer;
begin
 assign(f,SciezkaDane+'Rysunki.ima');
 reset(f,1);
 for a:=1 to IloscIkon do
  begin
   GetMem(Ikony[a],RozmiarIkon);
   BlockRead(f,Ikony[a]^,RozmiarIkon);
  end;
 close(f);
end;

procedure PlanszaKoniec;
var
 a,b:byte;
begin
 for a:=1 to 20 do
  for b:=1 to 13 do
   if Plansza[a,b]<>nil then
    begin
     dispose(Plansza[a,b],Koniec);
     Plansza[a,b]:=nil;
    end;
end;
procedure DaneKoniec;
var
 a:integer;
begin
 for a:=1 to IloscIkon do
  if Ikony[a]<>nil then
   FreeMem(Ikony[a],RozmiarIkon);
end;
procedure PustaPlansza;
var
 a,b:byte;
 X,Y:integer;
begin
 for a:=0 to 12 do
  for b:=0 to 19 do
   begin
    X:=32*b;
    Y:=32*a;
    New(Plansza[b,a],Init(X,Y,UtworzNic,'   .',WNic));
    Plansza[b,a]^.Wyswietl;
   end;
end;
procedure NowaPlansza(APr:TProc;X,Y:integer;Kod:string;Rys:PRys;var Plansza:PPole);
begin
 New(Plansza,Init(X,Y,Rys,Kod,APr));
 Plansza^.Wyswietl;
end;
function PodajLiczbe(Znak:char;Max:byte):byte;
var
 a:byte;
begin
 a:=ord(Znak);
 if a>48 then
  begin
   a:=a-47;
   while a>Max do
    a:=a-Max;
   PodajLiczbe:=a;
  end
 else
  PodajLiczbe:=1;
end;
procedure OdczytajPlansze(Nazwa:string);
var
 f:Text;
 KPole:TTablica3;
 s:string80;
 a,b,c:integer;
 k1,k2,k3,k4:char;
 X,Y:integer;
begin
 if FileExists(SciezkaLevels+Nazwa) then
  begin
   HideCursor;
   PlanszaKoniec;
   assign(f,SciezkaLevels+Nazwa);
   reset(f);
   for a:=1 to 13 do
    begin
     readln(f,s);
     for b:=0 to 19 do
      KPole[b+1,a]:=copy(s,b*4+1,4);
    end;
   readln(f,s);
   close(f);
   NazwaW:=s;
   for b:=1 to 13 do
    for a:=1 to 20 do
     begin
      X:=(a-1)*32;
      Y:=(b-1)*32;
      k1:=KPole[a,b][1];
      k2:=KPole[a,b][2];
      k3:=KPole[a,b][3];
      k4:=KPole[a,b][4];
      if k1<>' ' then
       begin
        case k1 of
         'X': NowaPlansza(WTNT,X,Y,KPole[a,b],UtworzTNT,Plansza[a,b]);
         '<': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WSplitter,X,Y,KPole[a,b],UtworzSplitter(c),Plansza[a,b]);
                   end;
               '.':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WSplitter,X,Y,KPole[a,b],UtworzRotSplitter(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WSplitter,X,Y,KPole[a,b],UtworzRotSplitter(c),Plansza[a,b]);
                   end;
              end;
         'O': case k3 of
               'R':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KR),Plansza[a,b]);
               'G':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KG),Plansza[a,b]);
               'B':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KB),Plansza[a,b]);
               'Y':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KRG),Plansza[a,b]);
               'C':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KGB),Plansza[a,b]);
               ' ':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KRGB),Plansza[a,b]);
               'M':NowaPlansza(WCoin,X,Y,KPole[a,b],UtworzCoin(KRB),Plansza[a,b]);
              end;
         '=': case k2 of
               ' ':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(6),Plansza[a,b]);
               '1':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(4),Plansza[a,b]);
               '2':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(7),Plansza[a,b]);
               '3':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(9),Plansza[a,b]);
               '4':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(10),Plansza[a,b]);
               '5':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(3),Plansza[a,b]);
               '6':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(8),Plansza[a,b]);
               '7':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(5),Plansza[a,b]);
               '8':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(6),Plansza[a,b]);
               '9':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(4),Plansza[a,b]);
              end;
         '#': case k2 of
               ' ':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(1),Plansza[a,b]);
               '1':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(2),Plansza[a,b]);
               '2':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(3),Plansza[a,b]);
               '3':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(4),Plansza[a,b]);
               '4':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(1),Plansza[a,b]);
               '5':NowaPlansza(WRamka,X,Y,KPole[a,b],UtworzRamke(2),Plansza[a,b]);
               '6':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(1),Plansza[a,b]);
               '7':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(2),Plansza[a,b]);
               '8':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(3),Plansza[a,b]);
               '9':NowaPlansza(WMur,X,Y,KPole[a,b],UtworzMur(4),Plansza[a,b]);
              end;
         'F': case k3 of
               'R':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KR),Plansza[a,b]);
               'G':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KG),Plansza[a,b]);
               'B':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KB),Plansza[a,b]);
               'Y':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KRG),Plansza[a,b]);
               'C':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KGB),Plansza[a,b]);
               ' ':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KRGB),Plansza[a,b]);
               'M':NowaPlansza(WFiltr0,X,Y,KPole[a,b],UtworzFiltr0(KRB),Plansza[a,b]);
              end;
         ':': begin
               if k2 in [' ','4','8'] then
                   case k3 of
                    'R':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KR),Plansza[a,b]);
                    'G':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KG),Plansza[a,b]);
                    'B':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KB),Plansza[a,b]);
                    'Y':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KRG),Plansza[a,b]);
                    'C':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KGB),Plansza[a,b]);
                    ' ':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KRGB),Plansza[a,b]);
                    'M':NowaPlansza(WFiltr1,X,Y,KPole[a,b],UtworzFiltr1(KRB),Plansza[a,b]);
                   end;
               if k2 in ['1','5','9'] then
                   case k3 of
                    'R':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KR),Plansza[a,b]);
                    'G':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KG),Plansza[a,b]);
                    'B':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KB),Plansza[a,b]);
                    'Y':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KRG),Plansza[a,b]);
                    'C':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KGB),Plansza[a,b]);
                    ' ':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KRGB),Plansza[a,b]);
                    'M':NowaPlansza(WFiltr2,X,Y,KPole[a,b],UtworzFiltr2(KRB),Plansza[a,b]);
                   end;
               if k2 in ['2','6'] then
                   case k3 of
                    'R':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KR),Plansza[a,b]);
                    'G':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KG),Plansza[a,b]);
                    'B':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KB),Plansza[a,b]);
                    'Y':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KRG),Plansza[a,b]);
                    'C':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KGB),Plansza[a,b]);
                    ' ':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KRGB),Plansza[a,b]);
                    'M':NowaPlansza(WFiltr3,X,Y,KPole[a,b],UtworzFiltr3(KRB),Plansza[a,b]);
                   end;
               if k2 in ['3','7'] then
                   case k3 of
                    'R':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KR),Plansza[a,b]);
                    'G':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KG),Plansza[a,b]);
                    'B':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KB),Plansza[a,b]);
                    'Y':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KRG),Plansza[a,b]);
                    'C':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KGB),Plansza[a,b]);
                    ' ':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KRGB),Plansza[a,b]);
                    'M':NowaPlansza(WFiltr4,X,Y,KPole[a,b],UtworzFiltr4(KRB),Plansza[a,b]);
                   end;
              end;
         '/': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WMirror,X,Y,KPole[a,b],UtworzMirror(c),Plansza[a,b]);
                   end;
               '.':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WMirror,X,Y,KPole[a,b],UtworzRotMirror(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WMirror,X,Y,KPole[a,b],UtworzRotMirror(c),Plansza[a,b]);
                   end;
              end;
         'R': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,4);
                    NowaPlansza(WRefractor,X,Y,KPole[a,b],UtworzRefractor(c),Plansza[a,b]);
                   end;
               '.':begin
                    c:=PodajLiczbe(k2,4);
                    NowaPlansza(WRefractor,X,Y,KPole[a,b],UtworzRotRefractor(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,4);
                    NowaPlansza(WRefractor,X,Y,KPole[a,b],UtworzRotRefractor(c),Plansza[a,b]);
                   end;
              end;
         '%': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,4);
                    NowaPlansza(WDMirror,X,Y,KPole[a,b],UtworzDMirror(c),Plansza[a,b]);
                   end;
               '.':begin
                    c:=PodajLiczbe(k2,4);
                    NowaPlansza(WDMirror,X,Y,KPole[a,b],UtworzRotDMirror(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,4);
                    NowaPlansza(WDMirror,X,Y,KPole[a,b],UtworzRotDMirror(c),Plansza[a,b]);
                   end;
              end;
         'W': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WOneWay,X,Y,KPole[a,b],UtworzOneWay(c),Plansza[a,b]);
                   end;
               '.':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WOneWay,X,Y,KPole[a,b],UtworzRotOneWay(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WOneWay,X,Y,KPole[a,b],UtworzRotOneWay(c),Plansza[a,b]);
                   end;
              end;
         'P': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WPrism,X,Y,KPole[a,b],UtworzPrism(c),Plansza[a,b]);
                   end;
               '.':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WPrism,X,Y,KPole[a,b],UtworzRotPrism(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WPrism,X,Y,KPole[a,b],UtworzRotPrism(c),Plansza[a,b]);
                   end;
              end;
         'S': case k4 of
               ' ':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WLaser,X,Y,KPole[a,b],UtworzLaser(c),Plansza[a,b]);
                   end;
               'r':begin
                    c:=PodajLiczbe(k2,8);
                    NowaPlansza(WLaser,X,Y,KPole[a,b],UtworzRotLaser(c),Plansza[a,b]);
                   end;
              end;
        end;
       end
      else
       NowaPlansza(WNic,X,Y,'   .',UtworzNic,Plansza[a,b]);
     end;
   WyswietlDane;
   ShowCursor;
  end
 else
  WInfo('Informacja','  Plik "'+Nazwa+'" nie istnieje !');
end;
end.