unit UProcedury;
interface
uses UObiekty;
const
 KR   = 4;   { Czerwony  }
 KG   = 2;   { Zielony   }
 KB   = 9;   { Niebieski }
 KRG  = 14;   { ty     }
 KRB  = 5;   { Fioletowy }
 KGB  = 11;   { Cyan      }
 KRGB = 15;   { Biay     }

function UtworzNic:PRys;
function UtworzTNT:PRys;
function UtworzCoin(Kolor:byte):PRys;
function UtworzFiltr0(Kolor:byte):PRys;
function UtworzFiltr1(Kolor:byte):PRys;
function UtworzFiltr2(Kolor:byte):PRys;
function UtworzFiltr3(Kolor:byte):PRys;
function UtworzFiltr4(Kolor:byte):PRys;
function UtworzMirror(Num:byte):PRys;
function UtworzRotMirror(Num:byte):PRys;
function UtworzLaser(Num:byte):PRys;
function UtworzRotLaser(Num:byte):PRys;
function UtworzMur(Num:byte):PRys;
function UtworzPrism(Num:byte):PRys;
function UtworzRotPrism(Num:Byte):PRys;
function UtworzOneWay(Num:byte):PRys;
function UtworzRotOneWay(Num:byte):PRys;
function UtworzDMirror(Num:byte):PRys;
function UtworzRotDMirror(Num:byte):PRys;
function UtworzRefractor(Num:byte):PRys;
function UtworzRotRefractor(Num:byte):PRys;
function UtworzSplitter(Num:byte):PRys;
function UtworzRotSplitter(Num:byte):PRys;
function UtworzRamke(Num:byte):PRys;

implementation

uses UDane;

function UtworzNic:PRys;
var
 Rys:PRys;
begin
 New(Rys);
 Rys^.Next:=Rys;
 Rys^.Ikona:=Ikony[1];
 UtworzNic:=Rys;
end;
function UtworzTNT:PRys;
var
 Rys:PRys;
begin
 New(Rys);
 Rys^.Next:=Rys;
 Rys^.Ikona:=Ikony[179];
 UtworzTNT:=Rys;
end;

function UtworzCoin(Kolor:byte):PRys;
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 case Kolor of
  KR  : a:=34;
  KG  : a:=43;
  KB  : a:=62;
  KRG : a:=14;
  KRB : a:=101;
  KGB : a:=82;
  KRGB: a:=23;
 end;
 new(Rys);
 Rys^.Ikona:=Ikony[a];
 Pomoc:=Rys;
 for b:=1 to 8 do
  begin
   new(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   Pomoc^.Ikona:=Ikony[a+b];
  end;
 Pomoc^.Next:=Rys;
 UtworzCoin:=Rys;
end;
function UtworzFiltr0(Kolor:byte):PRys;
var
 Rys:PRys;
 a:byte;
begin
 case Kolor of
  KR  : a:=96;
  KG  : a:=97;
  KB  : a:=98;
  KRG : a:=95;
  KRB : a:=100;
  KGB : a:=99;
  KRGB: a:=94;
 end;
 new(Rys);
 Rys^.Ikona:=Ikony[a];
 Rys^.Next:=Rys;
 UtworzFiltr0:=Rys;
end;
function UtworzFiltr1(Kolor:byte):PRys;
var
 Rys:PRys;
 a:byte;
begin
 case Kolor of
  KR  : a:=133;
  KG  : a:=134;
  KB  : a:=135;
  KRG : a:=132;
  KRB : a:=137;
  KGB : a:=136;
  KRGB: a:=131;
 end;
 new(Rys);
 Rys^.Ikona:=Ikony[a];
 Rys^.Next:=Rys;
 UtworzFiltr1:=Rys;
end;
function UtworzFiltr2(Kolor:byte):PRys;
var
 Rys:PRys;
 a:byte;
begin
 case Kolor of
  KR  : a:=140;
  KG  : a:=141;
  KB  : a:=142;
  KRG : a:=139;
  KRB : a:=144;
  KGB : a:=143;
  KRGB: a:=138;
 end;
 new(Rys);
 Rys^.Ikona:=Ikony[a];
 Rys^.Next:=Rys;
 UtworzFiltr2:=Rys;
end;
function UtworzFiltr3(Kolor:byte):PRys;
var
 Rys:PRys;
 a:byte;
begin
 case Kolor of
  KR  : a:=166;
  KG  : a:=167;
  KB  : a:=168;
  KRG : a:=129;
  KRB : a:=170;
  KGB : a:=169;
  KRGB: a:=128;
 end;
 new(Rys);
 Rys^.Ikona:=Ikony[a];
 Rys^.Next:=Rys;
 UtworzFiltr3:=Rys;
end;
function UtworzFiltr4(Kolor:byte):PRys;
var
 Rys:PRys;
 a:byte;
begin
 case Kolor of
  KR  : a:=161;
  KG  : a:=162;
  KB  : a:=163;
  KRG : a:=160;
  KRB : a:=165;
  KGB : a:=164;
  KRGB: a:=159;
 end;
 new(Rys);
 Rys^.Ikona:=Ikony[a];
 Rys^.Next:=Rys;
 UtworzFiltr4:=Rys;
end;
function UtworzMirror(Num:byte):PRys;
var
 Rys:PRys;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Num+73];
 Rys^.Next:=Rys;
 UtworzMirror:=Rys;
end;
function UtworzRotMirror(Num:byte):PRys;
const
 Tab:array[1..8] of byte = (74,75,76,77,78,79,80,81);
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 New(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 b:=num;
 for a:=Num+1 to Num+7 do
  begin
   New(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   dec(b);
   if b<1 then b:=8;
   Pomoc^.Ikona:=Ikony[Tab[b]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotMirror:=Rys;
end;
function UtworzLaser(Num:byte):PRys;
var
 Rys:PRys;
const
 Tab:array[1..8] of byte = (9,12,7,8,10,110,11,13);
begin
 New(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Rys^.Next:=Rys;
 UtworzLaser:=Rys;
end;
function UtworzRotLaser(Num:byte):PRys;
const
 Tab:array[1..8] of byte = (182,185,180,181,183,187,184,186);
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 New(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 b:=Num;
 for a:=Num+1 to Num+7 do
  begin
   New(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   dec(b);
   if b<1 then b:=8;
   Pomoc^.Ikona:=Ikony[Tab[b]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotLaser:=Rys;
end;
function UtworzMur(Num:byte):PRys;
const
 Tab:array[1..4] of byte = (2,3,4,130);
var
 Rys:PRys;
begin
 New(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Rys^.Next:=Rys;
 UtworzMur:=Rys;
end;
function UtworzPrism(Num:byte):PRys;
var
 Rys:PRys;
begin
 New(Rys);
 Rys^.Ikona:=Ikony[Num+53];
 Rys^.Next:=Rys;
 UtworzPrism:=Rys;
end;
function UtworzRotPrism(Num:Byte):PRys;
const
 Tab:array[1..8] of byte =(54,55,56,57,58,59,60,61);
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 b:=Num;
 for a:=Num+1 to Num+7 do
  begin
   new(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   dec(b);
   if b<1 then b:=8;
   Pomoc^.Ikona:=Ikony[Tab[b]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotPrism:=Rys;
end;
function UtworzOneWay(Num:byte):PRys;
var
 Rys:PRys;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Num+170];
 Rys^.Next:=Rys;
 UtworzOneWay:=Rys;
end;
function UtworzRotOneWay(Num:byte):PRys;
const
 Tab:array[1..8] of byte = (171,172,173,174,175,176,177,178);
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 b:=Num;
 for a:=Num+1 to Num+7 do
  begin
   new(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   dec(b);
   if b<1 then b:=8;
   Pomoc^.Ikona:=Ikony[Tab[b]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotOneWay:=Rys;
end;
function UtworzDMirror(Num:byte):PRys;
const
 Tab:array[1..4] of byte = (145,146,73,93);
var
 Rys:PRys;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Rys^.Next:=Rys;
 UtworzDMirror:=Rys;
end;
function UtworzRotDMirror(Num:byte):PRys;
const
 Tab:array[1..4] of byte = (145,146,73,93);
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 b:=Num;
 for a:=Num+1 to Num+3 do
  begin
   new(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   dec(b);
   if b<1 then b:=4;
   Pomoc^.Ikona:=Ikony[Tab[b]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotDMirror:=Rys;
end;
function UtworzRefractor(Num:byte):PRys;
var
 Rys:PRys;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Num+146];
 Rys^.Next:=Rys;
 UtworzRefractor:=Rys;
end;
function UtworzRotRefractor(Num:byte):PRys;
const
 Tab:array[1..8] of byte = (147,150,149,148,
                            147,150,149,148);
var
 Rys,Pomoc:PRys;
 a:byte;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 for a:=Num+1 to Num+3 do
  begin
   new(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   Pomoc^.Ikona:=Ikony[Tab[a]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotRefractor:=Rys;
end;
function UtworzSplitter(Num:byte):PRys;
var
 Rys:PRys;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Num+150];
 Rys^.Next:=Rys;
 UtworzSplitter:=Rys;
end;
function UtworzRotSplitter(Num:byte):PRys;
const
 Tab:array[1..8] of byte = (151,152,153,154,155,156,157,158);
var
 Rys,Pomoc:PRys;
 a,b:byte;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Pomoc:=Rys;
 b:=Num;
 for a:=Num+1 to Num+7 do
  begin
   new(Pomoc^.Next);
   Pomoc:=Pomoc^.Next;
   dec(b);
   if b<1 then b:=8;
   Pomoc^.Ikona:=Ikony[Tab[b]];
  end;
 Pomoc^.Next:=Rys;
 UtworzRotSplitter:=Rys;
end;
function UtworzRamke(Num:byte):PRys;
const
 Tab:array[1..10] of byte = (5,6,32,33,52,53,71,72,91,92);
var
 Rys:PRys;
begin
 new(Rys);
 Rys^.Ikona:=Ikony[Tab[Num]];
 Rys^.Next:=Rys;
 UtworzRamke:=Rys;
end;
end.