unit UWykonaj;
interface
uses UObiekty;
{$F+}
procedure WNic(Kierunek,R,G,B,XX,YY:byte);
procedure WMur(Kierunek,R,G,B,XX,YY:byte);
procedure WRamka(Kierunek,R,G,B,XX,YY:byte);
procedure WLaser(Kierunek,R,G,B,XX,YY:byte);
procedure WMirror(Kierunek,R,G,B,XX,YY:byte);
procedure WDMirror(Kierunek,R,G,B,XX,YY:byte);
procedure WFiltr0(Kierunek,R,G,B,XX,YY:byte);
procedure WFiltr1(Kierunek,R,G,B,XX,YY:byte);
procedure WFiltr2(Kierunek,R,G,B,XX,YY:byte);
procedure WFiltr3(Kierunek,R,G,B,XX,YY:byte);
procedure WFiltr4(Kierunek,R,G,B,XX,YY:byte);
procedure WOneWay(Kierunek,R,G,B,XX,YY:byte);
procedure WPrism(Kierunek,R,G,B,XX,YY:byte);
procedure WRefractor(Kierunek,R,G,B,XX,YY:byte);
procedure WSplitter(Kierunek,R,G,B,XX,YY:byte);
procedure WCoin(Kierunek,R,G,B,XX,YY:byte);
procedure WTNT(Kierunek,R,G,B,XX,YY:byte);

implementation
uses UDane;

procedure UstawRGB(Kr,R,G,B:byte;PP:PPole);
var
 Q,W:byte;
begin
 Q:=Kr;
 if Q and 1 = 1 then W:=Q+1;
 if Q and 1 = 0 then W:=Q-1;
 PP^.KPole[Q].R:=R or PP^.KPole[Q].R;
 PP^.KPole[Q].G:=G or PP^.KPole[Q].G;
 PP^.KPole[Q].B:=B or PP^.KPole[Q].B;
 PP^.KPole[W].R:=R or PP^.KPole[W].R;
 PP^.KPole[W].G:=G or PP^.KPole[W].G;
 PP^.KPole[W].B:=B or PP^.KPole[W].B;
 PP^.KPole[W].Bl:=true;
 PP^.KPole[Q].Bl:=true;
end;
procedure UstawPRGB(Kr,R,G,B:byte;PP:PPole);
begin
 PP^.KPole[Kr].R:=R or PP^.KPole[Kr].R ;
 PP^.KPole[Kr].G:=G or PP^.KPole[Kr].G;
 PP^.KPole[Kr].B:=B or PP^.KPole[Kr].B;
 PP^.KPole[Kr].Bl:=true;
end;
procedure Zmien(Kierunek:byte;var XX,YY:byte);
begin
 case kierunek of
  1:begin dec(YY); end;
  2:begin inc(YY); end;
  3:begin inc(XX);dec(YY); end;
  4:begin dec(XX);inc(YY); end;
  5:begin inc(XX); end;
  6:begin dec(XX); end;
  7:begin inc(XX);inc(YY); end;
  8:begin dec(XX);dec(YY); end;
 end;
end;

procedure WNic(Kierunek,R,G,B,XX,YY:byte);
begin
 if Kierunek<>0 then
  begin
   UstawRGB(Kierunek,R,G,B,Plansza[XX,YY]);
   Zmien(Kierunek,XX,YY);
   Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
  end
end;
procedure WRamka(Kierunek,R,G,B,XX,YY:byte);
begin
 if Kierunek<>0 then
  begin
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
  end
end;
procedure WMur(Kierunek,R,G,B,XX,YY:byte);
begin
end;
procedure WLaser(Kierunek,R,G,B,XX,YY:byte);
var
 Nx,Ny:byte;
begin
if Kierunek=0 then
 begin
  case Plansza[XX,YY]^.Kod[3] of
   ' ':begin R:=1; G:=1; B:=1; end;
   'R':begin R:=1; G:=0; B:=0; end;
   'G':begin R:=0; G:=1; B:=0; end;
   'B':begin R:=0; G:=0; B:=1; end;
   'Y':begin R:=1; G:=1; B:=0; end;
   'C':begin R:=0; G:=1; B:=1; end;
   'M':begin R:=1; G:=0; B:=1; end;
  end;
  case Plansza[XX,YY]^.Kod[2] of
   ' ':Kierunek:=1;
   '1':Kierunek:=3;
   '2':Kierunek:=5;
   '3':Kierunek:=7;
   '4':Kierunek:=2;
   '5':Kierunek:=4;
   '6':Kierunek:=6;
   '7':Kierunek:=8;
   '8':Kierunek:=1;
   '9':Kierunek:=3;
  end;
  Zmien(Kierunek,XX,YY);
  if Kierunek<>0 then
   Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
 end;
end;
procedure WMirror(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
 StaryKierunek:byte;
begin
if Kierunek<>0 then
 begin
  StaryKierunek:=Kierunek;
  Kod:=Plansza[XX,YY]^.Kod[2];
  if Kierunek and 1 = 1 then
   UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
  else
   UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
  case Kierunek of
   1: case Kod of
       '5':Kierunek:=6;
       '3':Kierunek:=5;
      end;
   2: case Kod of
       '7':Kierunek:=6;
       '1':Kierunek:=5;
      end;
   3: case Kod of
       '4':Kierunek:=7;
       '6':Kierunek:=8;
      end;
   4: case Kod of
       '2':Kierunek:=7;
       ' ':Kierunek:=8;
      end;
   5: case Kod of
       '7':Kierunek:=1;
       '5':Kierunek:=2;
      end;
   6: case Kod of
       '1':Kierunek:=1;
       '3':Kierunek:=2;
      end;
   7: case Kod of
       ' ':Kierunek:=3;
       '6':Kierunek:=4;
      end;
   8: case Kod of
       '4':Kierunek:=4;
       '2':Kierunek:=3;
      end;
  end;
  if Kierunek<>StaryKierunek then
   UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
  Zmien(Kierunek,XX,YY);
  if Kierunek<>StaryKierunek then
   Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
 end;
end;
procedure WDMirror(Kierunek,R,G,B,XX,YY:byte);
var
 StaryKierunek:byte;
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   StaryKierunek:=Kierunek;
   Kod:=Plansza[XX,YY]^.Kod[2];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   case Kierunek of
    1:case Kod of
       '1':Kierunek:=6;
       '3':Kierunek:=5;
      end;
    2:case Kod of
       '1':Kierunek:=5;
       '3':Kierunek:=6;
      end;
    3:case Kod of
       ' ':Kierunek:=7;
       '2':Kierunek:=8;
      end;
    4:case Kod of
       ' ':Kierunek:=8;
       '2':Kierunek:=7;
      end;
    5:case Kod of
       '1':Kierunek:=2;
       '3':Kierunek:=1;
      end;
    6:case Kod of
       '1':Kierunek:=1;
       '3':Kierunek:=2;
      end;
    7:case Kod of
       ' ':Kierunek:=3;
       '2':Kierunek:=4;
      end;
    8:case Kod of
       ' ':Kierunek:=4;
       '2':Kierunek:=3;
      end;
   end;
   if Kierunek<>StaryKierunek then
    UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
   Zmien(Kierunek,XX,YY);
   if Kierunek<>StaryKierunek then
    Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
  end;
end;
procedure WFiltr0(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[3];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   case Kod of
    ' ':begin R:=R and 1; G:=G and 1; B:=B and 1; end;
    'R':begin R:=R and 1; G:=G and 0; B:=B and 0; end;
    'G':begin R:=R and 0; G:=G and 1; B:=B and 0; end;
    'B':begin R:=R and 0; G:=G and 0; B:=B and 1; end;
    'Y':begin R:=R and 1; G:=G and 1; B:=B and 0; end;
    'C':begin R:=R and 0; G:=G and 1; B:=B and 1; end;
    'M':begin R:=R and 1; G:=G and 0; B:=B and 1; end;
   end;
   if (R<>0)or(G<>0)or(B<>0) then
    begin
     UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
     Zmien(Kierunek,XX,YY);
     Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
    end;
  end;
end;
procedure WFiltr1(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[3];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   if Kierunek in [1,2] then
    begin
     case Kod of
      ' ':begin R:=R and 1; G:=G and 1; B:=B and 1; end;
      'R':begin R:=R and 1; G:=G and 0; B:=B and 0; end;
      'G':begin R:=R and 0; G:=G and 1; B:=B and 0; end;
      'B':begin R:=R and 0; G:=G and 0; B:=B and 1; end;
      'Y':begin R:=R and 1; G:=G and 1; B:=B and 0; end;
      'C':begin R:=R and 0; G:=G and 1; B:=B and 1; end;
      'M':begin R:=R and 1; G:=G and 0; B:=B and 1; end;
     end;
     if (R<>0)or(G<>0)or(B<>0) then
      begin
       UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
       Zmien(Kierunek,XX,YY);
       Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
      end;
    end
  end;
end;
procedure WFiltr2(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[3];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   if Kierunek in [4,3] then
    begin
     case Kod of
      ' ':begin R:=R and 1; G:=G and 1; B:=B and 1; end;
      'R':begin R:=R and 1; G:=G and 0; B:=B and 0; end;
      'G':begin R:=R and 0; G:=G and 1; B:=B and 0; end;
      'B':begin R:=R and 0; G:=G and 0; B:=B and 1; end;
      'Y':begin R:=R and 1; G:=G and 1; B:=B and 0; end;
      'C':begin R:=R and 0; G:=G and 1; B:=B and 1; end;
      'M':begin R:=R and 1; G:=G and 0; B:=B and 1; end;
     end;
     if (R<>0)or(G<>0)or(B<>0) then
      begin
       UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
       Zmien(Kierunek,XX,YY);
       Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
      end;
    end
  end;
end;
procedure WFiltr3(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[3];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   if Kierunek in [5,6] then
    begin
     case Kod of
      ' ':begin R:=R and 1; G:=G and 1; B:=B and 1; end;
      'R':begin R:=R and 1; G:=G and 0; B:=B and 0; end;
      'G':begin R:=R and 0; G:=G and 1; B:=B and 0; end;
      'B':begin R:=R and 0; G:=G and 0; B:=B and 1; end;
      'Y':begin R:=R and 1; G:=G and 1; B:=B and 0; end;
      'C':begin R:=R and 0; G:=G and 1; B:=B and 1; end;
      'M':begin R:=R and 1; G:=G and 0; B:=B and 1; end;
     end;
     if (R<>0)or(G<>0)or(B<>0) then
      begin
       UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
       Zmien(Kierunek,XX,YY);
       Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
      end;
    end
  end;
end;
procedure WFiltr4(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[3];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   if Kierunek in [8,7] then
    begin
     case Kod of
      ' ':begin R:=R and 1; G:=G and 1; B:=B and 1; end;
      'R':begin R:=R and 1; G:=G and 0; B:=B and 0; end;
      'G':begin R:=R and 0; G:=G and 1; B:=B and 0; end;
      'B':begin R:=R and 0; G:=G and 0; B:=B and 1; end;
      'Y':begin R:=R and 1; G:=G and 1; B:=B and 0; end;
      'C':begin R:=R and 0; G:=G and 1; B:=B and 1; end;
      'M':begin R:=R and 1; G:=G and 0; B:=B and 1; end;
     end;
     if (R<>0)or(G<>0)or(B<>0) then
      begin
       UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
       Zmien(Kierunek,XX,YY);
       Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
      end;
    end
  end;
end;
procedure WOneWay(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
 StaryKierunek:byte;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[2];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   StaryKierunek:=Kierunek;
   case Kod of
     ' ':Kierunek:=1;
     '1':Kierunek:=3;
     '2':Kierunek:=5;
     '3':Kierunek:=7;
     '4':Kierunek:=2;
     '5':Kierunek:=4;
     '6':Kierunek:=6;
     '7':Kierunek:=8;
   end;
   if Kierunek=StaryKierunek then
    begin
     UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
     Zmien(Kierunek,XX,YY);
     Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
    end;
  end;
end;
procedure WPrism(Kierunek,R,G,B,XX,YY:byte);
var
 Kod:char;
 StaryKierunek,SK2:byte;
 Ok:boolean;
procedure Wykonaj(Kierunek,R,G,B,XX,YY:byte);
var
 K:byte;
 SX,SY:byte;
begin
 K:=Kierunek;
 SX:=XX;
 SY:=YY;
 if R<>0 then
  begin
   UstawPRGB(Kierunek,1,0,0,Plansza[XX,YY]);
   Zmien(Kierunek,XX,YY);
   Plansza[XX,YY]^.Wykonaj(Kierunek,R,0,0,XX,YY);
  end;
 XX:=SX;
 YY:=SY;
 if B<>0 then
  begin
   inc(Kierunek,4);
   case Kierunek of
    10:Kierunek:=1;
    12:Kierunek:=3;
   end;
   if Kierunek>8 then
    dec(Kierunek,7);
   UstawPRGB(Kierunek,0,0,B,Plansza[XX,YY]);
   Zmien(Kierunek,XX,YY);
   Plansza[XX,YY]^.Wykonaj(Kierunek,0,0,B,XX,YY);
  end;
 Kierunek:=K;
 XX:=SX;
 YY:=SY;
 if G<>0 then
  begin
   inc(Kierunek,2);
   if Kierunek=10 then
    Kierunek:=1;
   if Kierunek>8 then
    dec(Kierunek,7);
   UstawPRGB(Kierunek,0,G,0,Plansza[XX,YY]);
   Zmien(Kierunek,XX,YY);
   Plansza[XX,YY]^.Wykonaj(Kierunek,0,G,0,XX,YY);
  end;
end;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[2];
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   StaryKierunek:=Kierunek;
   case Kod of
    ' ':Kierunek:=1;
    '1':Kierunek:=3;
    '2':Kierunek:=5;
    '3':Kierunek:=7;
    '4':Kierunek:=2;
    '5':Kierunek:=4;
    '6':Kierunek:=6;
    '7':Kierunek:=8;
   end;
   if Kierunek=StaryKierunek then
    begin
     case Kod of
      ' ':Wykonaj(Kierunek,R,G,B,XX,YY);
      '1':Wykonaj(Kierunek,R,G,B,XX,YY);
      '2':Wykonaj(Kierunek,R,G,B,XX,YY);
      '3':Wykonaj(Kierunek,R,G,B,XX,YY);
      '4':Wykonaj(Kierunek,R,G,B,XX,YY);
      '5':Wykonaj(Kierunek,R,G,B,XX,YY);
      '6':Wykonaj(Kierunek,R,G,B,XX,YY);
      '7':Wykonaj(Kierunek,R,G,B,XX,YY);
     end;
    end
   else
    begin
     Ok:=false;
     case StaryKierunek of
      1: case Kod of
          '2':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '3':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '4':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      2: case Kod of
          '6':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '7':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          ' ':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      3: case Kod of
          '3':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '4':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '5':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      4: case Kod of
          '7':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          ' ':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '1':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      5: case Kod of
          '4':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '5':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '6':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      6: case Kod of
          ' ':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '1':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '2':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      7: case Kod of
          '5':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '6':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '7':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
      8: case Kod of
          ' ':begin
               Ok:=True;
               R:=R and 0;
               G:=G and 0;
              end;
          '1':begin
               Ok:=True;
               R:=R and 0;
               B:=B and 0;
              end;
          '2':begin
               Ok:=True;
               B:=B and 0;
               G:=G and 0;
              end;
         end;
     end;
     if Ok and ((R<>0)or(G<>0)or(B<>0)) then
      begin
       if Kierunek and 1 = 1 then
        Kierunek:=Kierunek+1
       else
        Kierunek:=Kierunek-1;
       UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
       Zmien(Kierunek,XX,YY);
       Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
      end;
    end;
  end;
end;
procedure WRefractor(Kierunek,R,G,B,XX,YY:byte);
var
 StaryKierunek:byte;
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   StaryKierunek:=Kierunek;
   Kod:=Plansza[XX,YY]^.Kod[2];
   case Kierunek of
    1:case Kod of
       ' ':Kierunek:=3;
       '3':Kierunek:=8;
      end;
    2:case Kod of
       ' ':Kierunek:=4;
       '3':Kierunek:=7;
      end;
    3:case Kod of
       ' ':Kierunek:=1;
       '1':Kierunek:=5;
      end;
    4:case Kod of
       ' ':Kierunek:=2;
       '1':Kierunek:=6;
      end;
    5:case Kod of
       '2':Kierunek:=7;
       '1':Kierunek:=3;
      end;
    6:case Kod of
       '2':Kierunek:=8;
       '1':Kierunek:=4;
      end;
    7:case Kod of
       '3':Kierunek:=2;
       '2':Kierunek:=5;
      end;
    8:case Kod of
       '3':Kierunek:=1;
       '2':Kierunek:=6;
      end;
   end;
   if Kierunek<>StaryKierunek then
    begin
     UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
     Zmien(Kierunek,XX,YY);
     Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
    end;
  end;
end;
procedure WSplitter(Kierunek,R,G,B,XX,YY:byte);
var
 K1,K2,StaryKierunek,SX,SY:byte;
 Kod:char;
begin
 if Kierunek<>0 then
  begin
   Kod:=Plansza[XX,YY]^.Kod[2];
   StaryKierunek:=Kierunek;
   if Kierunek and 1 = 1 then
    UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY])
   else
    UstawPRGB(Kierunek-1,R,G,B,Plansza[XX,YY]);
   case Kierunek of
    1:if Kod='4' then Kierunek:=5;
    2:if Kod=' ' then Kierunek:=5;
    3:if Kod='5' then Kierunek:=7;
    4:if Kod='1' then Kierunek:=7;
    5:if Kod='6' then Kierunek:=1;
    6:if Kod='2' then Kierunek:=1;
    7:if Kod='7' then Kierunek:=3;
    8:if Kod='3' then Kierunek:=3;
   end;
   if Kierunek<>StaryKierunek then
    begin
     UstawPRGB(Kierunek,R,G,B,Plansza[XX,YY]);
     UstawPRGB(Kierunek+1,R,G,B,Plansza[XX,YY]);
     SX:=XX;
     SY:=YY;
     Zmien(Kierunek,XX,YY);
     Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
     Zmien(Kierunek+1,SX,SY);
     Plansza[SX,SY]^.Wykonaj(Kierunek+1,R,G,B,SX,SY);
    end;
  end;
end;
procedure WCoin(Kierunek,R,G,B,XX,YY:byte);
begin
 if Kierunek<>0 then
  begin
   UstawRGB(Kierunek,R,G,B,Plansza[XX,YY]);
   Zmien(Kierunek,XX,YY);
   Plansza[XX,YY]^.Wykonaj(Kierunek,R,G,B,XX,YY);
  end
end;
procedure WTNT(Kierunek,R,G,B,XX,YY:byte);
begin
 if Kierunek<>0 then
  KoniecGry:=true;
 WNic(Kierunek,R,G,B,XX,YY);
end;

end.